import javax.microedition.lcdui.*;

public class SelectStation extends List implements CommandListener {
    static Image metroImage;
    
    static { 
        try { 
            metroImage = Image.createImage("/metro.png");
        } catch (java.io.IOException err) {
            // ignore the image loading failure the application can recover.
        }
    }


    static String[] getLineNames(Line[] lines) { 
        String[] lineNames = new String[lines.length+1];
        lineNames[0] = Locale.ALL_STATIONS;
        for (int i = 0; i < lines.length; i++) { 
            lineNames[i+1] = lines[i].name;
        }
        return lineNames;
    }

    static Image[] getLineIcons(Line[] lines) { 
        Image[] images = new Image[lines.length+1];
        images[0] = metroImage;
        for (int i = 0; i < lines.length; i++) { 
            images[i+1] = lines[i].image;
        }
        return images;
    }


    public SelectStation() {
        super(Locale.LINES, IMPLICIT, getLineNames(Scheme.instance.metroLines), getLineIcons(Scheme.instance.metroLines));
        setCommandListener(this);
        addCommand(MetroNavigator.BACK_CMD);
        Display.getDisplay(MetroNavigator.getInstance()).setCurrent(this);        
    }

    public void commandAction(Command c, Displayable d)  {
        MetroNavigator navigator = MetroNavigator.getInstance();
        if (c == MetroNavigator.BACK_CMD) { 
            Display.getDisplay(navigator).setCurrent(navigator.viewer);
        } else { 
            int i = getSelectedIndex();
            switch (i) { 
            case 0:
                new AllStationList();
                break;
            case -1:
                break;
            default:
                new LineStationList(i-1);
            }
        }
    }
}
